/* $Id: Charset.xs,v 1.2 1998/10/24 18:13:10 arlexa Exp $ */
/*
 * Apache::Charset.xs - mod_perl interface to Russian Apache (http://apache.lexa.ru)
 * internals
 *
 * Copyright (C) 1998, Alex Tutubalin <lexa@lexa.ru>
 *
 */




#include "modules/perl/mod_perl.h"
#ifndef RUSSIAN_APACHE
#error 'You should use this module with Russian Apache only. See http://apache.lexa.ru for details'
#endif
#include "include/httpd.h"
#include "modules/extra/mod_charset.h"
#if MOD_CHARSET_MAGIC < 19981025
#error 'You should upgrade your Russian Apache to (at least) PL27.0'
#endif


extern module charset_module;



MODULE = Apache::Charset	PACKAGE = Apache::Charset

PROTOTYPES: ENABLE

int
xs_is_ok(r)
Apache r

  CODE:
  if (ra_charset_ok(r))
    RETVAL = 1;
  else
    XSRETURN_UNDEF;

  OUTPUT:
  RETVAL

  
char *
xs_server_charset(r)
Apache r
 CODE:
  if(ra_charset_ok(r))
   RETVAL=ra_server_charset(r);
  else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL
  

char *
xs_client_charset(r)
Apache r
 CODE:
  if(ra_charset_ok(r))
   RETVAL=ra_client_charset(r);
  else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL
  

int
xs_no_of_charsets(r)
Apache r
 CODE:
  if(ra_charset_ok(r))
   RETVAL=ra_no_of_charsets(r);
  else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL
  

char*
xs_nth_charset_name(r,i)
Apache r
int i
 CODE:
 if(ra_charset_ok(r))
   RETVAL=ra_charset_name(r,i);
 else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL
  
char *
xs_server2client(r,s)
Apache r
char *s
 CODE:
 if(ra_charset_ok(r))
   RETVAL=ra_str_server2client(r,s);
 else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL

char *
xs_server2client_esc(r,s)
Apache r
char *s
 CODE:
 if(ra_charset_ok(r))
   RETVAL=ra_str_server2client_esc(r,s);
 else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL

char *
xs_client2server(r,s)
Apache r
char *s
 CODE:
 if(ra_charset_ok(r))
   RETVAL=ra_str_client2server(r,s);
 else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL

char *
xs_client2server_esc(r,s)
Apache r
char *s
 CODE:
 if(ra_charset_ok(r))
   RETVAL=ra_str_client2server_esc(r,s);
 else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL

pool *
xs_create_subpool(r)
Apache r
 CODE:
 RETVAL=ap_make_sub_pool(r->pool);

 OUTPUT:
  RETVAL

void
xs_delete_subpool(p)
pool *p

 CODE:
 ap_destroy_pool(p);


char *
xs_recode_str(r,p,from,to,data)
Apache r
pool *p
 char *from
 char *to
 char *data

  CODE:
  if(ra_charset_ok(r))
	RETVAL=ra_recode_str(r,p,from,to,data);
 else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL

char *
xs_recode_str_esc(r,p,from,to,data)
Apache r
pool* p
 char *from
 char *to
 char *data

  CODE:
  if(ra_charset_ok(r))
	RETVAL=ra_recode_str_esc(r,p,from,to,data);
 else
   XSRETURN_UNDEF;

  OUTPUT:
   RETVAL

